
' *********************************************************
' *    Rom  16K  32K  Bin  *
' *********************************************************

' 
BinArray = Array(&hFE,&h00,&h88,&h3C,&hC8,&h05,&hC8,&h00)

Gm1 = Array(&hFF,&h00,&hFF,&h00,&hFF,&hDB,&hA8,&h08,&h3E,&h80,&h21,&h00,&h40,&hF5,&hE5,&hCD, _
	    &h24,&h00,&hE1,&h36,&h55,&hCB,&h0E,&h7E,&hFE,&hAA,&h28,&h08,&hF1,&h3C,&hE6,&h0F, _
	    &hF6,&h80,&h18,&hE9,&hF1,&h21,&h00,&h88,&h11,&h00,&h40,&h01,&h00,&h40,&hED,&hB0, _
	    &h00,&h00,&h00,&h08,&hD3,&hA8,&hC9,&h00,&hFF,&h00,&hFF,&h00,&hFF)

Gm2 = Array(&hFF,&h00,&hFF,&h00,&hFF,&h3E,&h80,&h21,&h00,&h40,&hF5,&hE5,&hCD,&h24,&h00,&hE1, _
	    &h36,&h55,&hCB,&h0E,&h7E,&hFE,&hAA,&h28,&h08,&hF1,&h3C,&hE6,&h0F,&hF6,&h80,&h18, _
	    &hE9,&hF1,&h21,&h00,&h88,&h11,&h00,&h80,&h01,&h00,&h40,&hED,&hB0,&h00,&h00,&h00, _
	    &h00,&h00,&h00,&h08,&hD3,&hA8,&hC9,&h00,&hFF,&h00,&hFF,&h00,&hFF)

' 
Set objArgs = WScript.Arguments
Set objFSO = CreateObject("Scripting.FileSystemObject")

' 
Const ForAppending = 8
Const ForReading = 1
Const ForWriting = 2


' 
FileIn=""
FileInLen=0
FileOut=""

'  
 
'   
index = objArgs.Count - 1 
txtIn = ""
For i = 0 To index
	txtIn = txtIn + objArgs(i)+ " "
Next

IF txtIn="" Then
	txt="  " & VbCrLf & _
	    "RomToBin.vbs <FileName.rom>"
	WScript.Echo txt
	WScript.Quit
End IF

'    
FileIn=Trim(txtIn)

'   ,   -  
IF Not objFSO.FileExists(FileIn) Then
	WScript.Echo"File not found"
	WScript.Quit
End IF

'   
'   16K   32K,   
Set objFile = objFSO.GetFile(FileIn)
FileInLen=objFile.Size
Set objFile = Nothing
IF (FileInLen < 16384) Or (FileInLen > 32768) Then
	WScript.Echo"Bad file lenght"
	WScript.Quit
End IF

'   
index = InStrRev(FileIn,".")
IF index<0 Then
	index=Len(FileIn)
Else
	index=index - 1
End IF
	
'   
Set objFileIn = objFSO.OpenTextFile (FileIn, ForReading, False)
objFileIn.Skip(2)
StAdrL = Asc(objFileIn.Read(1))
StAdrH = Asc(objFileIn.Read(1))
objFileIn.Close


'   
Set objFileIn = objFSO.OpenTextFile (FileIn, ForReading, False)

'  Rom 16K
IF FileInLen = 16384 Then
	'  
	FileOut=Left(FileIn,Index) & ".bin"
	'   
	Set objFileOut = objFSO.OpenTextFile (FileOut, ForWriting, True)
	'  bin 
	Call WriteBinTitle(objFileOut)
 	'   roma
	Call WriteRom(objFileIn,objFileOut)
 	'        
	IF StAdrH < &h80 Then
		Gm1(48) = &hC3
		Gm1(49) = StAdrL
		Gm1(50) = StAdrH
		Call WriteMemTransfer(Gm1,objFileOut)	
	Else
		Gm2(48) = &hC3
		Gm2(49) = StAdrL
		Gm2(50) = StAdrH	
 		Call WriteMemTransfer(Gm2,objFileOut)
	End IF
	'  
	objFileOut.Close
	Set objFileOut = Nothing
Else
	'  rom 32K,     
	For j=1 To 2
		FileOut=Left(FileIn,Index) & j & ".bin"
		Set objFileOut = objFSO.OpenTextFile (FileOut, ForWriting, True)
		' bin 
		Call WriteBinTitle(objFileOut)
 		'  roma
		Call WriteRom(objFileIn,objFileOut)
 		' 
		IF j=1 Then
			Call WriteMemTransfer(Gm1,objFileOut)
		Else
	        	'   
			Gm2(48) = &hC3
			Gm2(49) = StAdrL
			Gm2(50) = StAdrH
			Call WriteMemTransfer(Gm2,objFileOut)
		End IF
 		'  
		objFileOut.Close
	Next
	Set objFileOut = Nothing
End IF

'   
objFileIn.Close
Set objFileIn = Nothing	

' 
Sub WriteBinTitle(Dst)
For i=0 To 6
	Dst.Write Chr(BinArray(i))
Next
End Sub

Sub WriteRom(Src,Dst)
For i=0 To 16383
	ch = Src.Read(1)
	Dst.Write (ch)
Next
End Sub

Sub WriteMemTransfer(Src,Dst)
For i=0 To 60
	Dst.Write Chr(Src(i))
Next
End Sub


'  
Set objArgs = Nothing
Set objFSO  = Nothing
